%{
#ifndef lint
static char Rcs_Id[] =
	"$Header: /h/guests/fmg/johnh/GEOFF_CVS/xcron/batch/lex.l,v 1.6 1995/11/27 05:04:08 geoff Exp $";
#endif

/*
 * $Log: lex.l,v $
 * Revision 1.6  1995/11/27 05:04:08  geoff
 * Cosmetic RCS header changes.
 *
 * Revision 1.5  87/01/10  23:29:38  geoff
 * Change the bzeros into memsets.
 * 
 * Revision 1.4  86/11/29  16:00:52  geoff
 * Make changes to support configurability.  Mostly, these involve changing
 * BSD ifdef's to more feature-specific ones.
 * 
 * Revision 1.3  86/07/07  00:00:19  geoff
 * Fix a bunch of lint complaints.
 * 
 * Revision 1.2  86/06/26  23:30:49  geoff
 * Major changes to make it portable to System V.
 * 
 */

#include "config.h"
#include "lex.h"
#include <signal.h>

struct klist {
	char *keyword;
	enum keyword keyvalue;
} klist[] = {
	"exec",		K_EXEC,
	"maxexec",	K_MAXEXEC,
	"maxqueue",	K_MAXQUEUE,
	"supervisor",	K_SUPERVISOR,
	"mail",		K_MAIL,
	"mailsupervisor", K_MAILSUPERVISOR,
	"console",	K_CONSOLE,
	"nice",		K_NICE,
	"restart",	K_RESTART,
	"time",		K_TIMECMD,
	"day",		K_DAY,
	"off",		K_OFF,
	"drain",	K_DRAIN,
	"on",		K_ON,
#ifdef HASLOADAVG
#ifdef SIGSTOP
	"loadstop",	K_LOADSTOP,
#endif
	"loadsched",	K_LOADSCHED,
#endif
#ifdef HASRLIMIT
	"cpulimit",	K_CPULIMIT,
	"rlimitcpu",	K_RLIMCPU,
	"rlimitfsize",	K_RLIMFSIZE,
	"rlimitdata",	K_RLIMDATA,
	"rlimitstack",	K_RLIMSTACK,
	"rlimitcore",	K_RLIMCORE,
	"rlimitrss",	K_RLIMRSS,
#endif
#ifdef ULIMIT
	"ulimitfsize",	K_RLIMFSIZE,
#endif
	0
};

%}

%%

[0-9]+				return (int) K_NUMBER;
[0-9]*[.][0-9]*			return (int) K_NUMBER;
[/0-9a-zA-Z_.-]+	{
				reg1 struct klist *kp;
				for(kp = klist ; kp->keyword ; kp++)
					if(strcmp(kp->keyword, yytext) == 0)
						return (int) (kp->keyvalue);
				return (int) K_VARIABLE;
			}

[0-9][0-9]:[0-9][0-9] 		return (int) K_TIME;

\n				return (int) K_LINE;

[ \t]				;

.				return (int) K_SYNTAX;

%%

lexfile(f)
FILE *f;
{
	extern struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
	extern int *yyfnd;
	extern int yyprevious;

	yylineno = 1;
	(void) memset (yytext, 0, YYLMAX * sizeof yytext[0]);
	(void) memset (yylstate, 0, sizeof yylstate);
	yylsp = yyolsp = 0;
	(void) memset (yysbuf, 0, YYLMAX * sizeof yysbuf[0]);
	yysptr = yysbuf;
	yyfnd = 0;
	yyprevious = YYNEWLINE;
	yyleng = 0;
	yymorfg = 0;
	yytchar = 0;
	yyin = f;
	yyestate = 0;
}

yywrap()
{
	return 1;
}
