#ifndef lint
static char Rcs_Id[] =
    "$Header: /h/guests/fmg/johnh/GEOFF_CVS/xcron/tellcron.c,v 2.8 1999/07/14 05:22:30 johnh Exp $";
#endif

/*
 * $Log: tellcron.c,v $
 * Revision 2.8  1999/07/14 05:22:30  johnh
 * location awareness (all in LOC_CRON) and a few cleanups/bugfixes
 *
 * Revision 2.7  1995/05/11 05:05:58  geoff
 * Minor RCS header changes.
 *
 * Revision 2.6  87/01/10  19:21:14  geoff
 * Don't complain about cron not being active when it doesn't matter.
 * 
 * Revision 2.5  86/12/01  14:46:57  geoff
 * Fix some lint complaints.
 * 
 * Revision 2.4  86/11/29  19:54:31  geoff
 * Change all the register declarations to be portable across
 * machines with varying numbers of registers.
 * 
 * Revision 2.3  86/04/17  22:00:57  geoff
 * Add support for compile-able RCS ID's and for the third argument to
 * sendcommand.
 * 
 * Revision 2.2  86/04/02  00:03:41  geoff
 * Fix the usage message.
 * 
 * Revision 2.1  86/03/30  13:51:32  geoff
 * Initial revision.
 * 
 */

#define GEN_ID				/* Generate source-control ID's */

#include "cron.h"			/* Just for the ID's */
#include <stdio.h>

int		main ();		/* "Crontab" command */
static void	tcusage ();		/* Issue usage message */

char *		progname;		/* Name we are running under */

extern void	exit ();		/* Exit from program */
extern char *	optarg;			/* Option argument pointer */
extern int	optind;			/* Index of argument to process */
extern int	sendcommand ();		/* Send command to the cron daemon */
extern void	setlibdir ();		/* Change directories to LIBDIR */

int main (argc, argv)			/* Crontab command */
    reg3 int		argc;		/* Argument count */
    reg1 char *		argv[];		/* Argument vector */
    {
    reg2 int		nextopt;	/* Next option from getopt */
    int			retval = 0;	/* Exit status */

    progname = argv[0];
    setlibdir ();
    while ((nextopt = getopt (argc, argv, "deLux:")) != EOF)
	{
	switch (nextopt)
	    {
#ifdef DUMP
	    case 'd':			/* Dump data structures */
		retval |= sendcommand ('D', "", 1);
		break;
#endif
	    case 'e':			/* Exit cron */
		if (sendcommand ('e', "", 1) == SEND_ERROR)
		    retval |= SEND_ERROR;
		return retval;
#ifdef LOC_CRON
	    case 'L':   /* new location */
		retval |= sendcommand('L', "", 1);
		break;
#endif /* LOC_CRON */
#ifdef DEBUG
	    case 'x':			/* Set debugging level */
		retval |= sendcommand ('x', optarg, 1);
		break;
#endif
	    case 'u':
		if (sendcommand ('u', "", 0) == SEND_ERROR)
		    retval |= SEND_ERROR;
		break;
	    default:
		tcusage ();
		/* NOTREACHED */
	    }
	}
    if (optind != argc)
	tcusage ();
    return retval;
    }

static void tcusage ()		/* Put out a usage message */
    {
	    char *debug = "";
	    char *lcron = "";
#ifdef DEBUG
	    debug = " [-x n]";
#endif /* DEBUG */
#ifdef LOC_CRON
	    lcron = " [-L]";
#endif /* LOC_CRON */
    (void) fprintf (stderr,
      "Usage:\ttellcron [-d] [-e] [-u]%s%s\n", debug, lcron);
    exit (1);
    /* NOTREACHED */
    }
